/*
 *   This file is a part of the SteamWar software.
 *
 *   Copyright (C) 2026 SteamWar.de-Serverteam
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package de.steamwar.kotlin.ui.context

import de.steamwar.kotlin.ui.StateFlowListener
import de.steamwar.kotlin.ui.RenderMarker
import de.steamwar.kotlin.ui.RenderObject
import org.bukkit.event.inventory.InventoryClickEvent
import org.bukkit.inventory.ItemStack

@RenderMarker
open class GroupContext(val parent: RenderParent?, val init: GroupContext.() -> Unit): StateFlowListener(), RenderObject, RenderParent {
    val children = mutableListOf<RenderObject>()
    val updatedSlots = mutableSetOf<Pair<Int, Int>>()

    override fun update() = render()

    override fun destroy() {
        children.forEach { it.destroy() }
        super.destroy()
    }

    init {
        init(this)
    }

    override fun renderItem(x: Int, y: Int, item: ItemStack, onClick: (event: InventoryClickEvent) -> Unit) {
        updatedSlots.add(x to y)
        parent?.renderItem(x, y, item, onClick)
    }

    override fun resetSlot(x: Int, y: Int) {
        parent?.resetSlot(x, y)
    }

    fun group(init: GroupContext.() -> Unit) {
        children.add(GroupContext(this, init))
    }

    override fun render() {
        children.forEach { it.destroy() }
        children.clear()
        val oldUpdatedSlots = updatedSlots.toList()
        updatedSlots.clear()
        init(this)
        (oldUpdatedSlots - updatedSlots).forEach { resetSlot(it.first, it.second) }
    }
}
